#ifndef __SX127X_H
#define __SX127X_H

#include <nuttx/spi/spi.h>
#include <stdint.h>

#define SX127X_IOC_SET_CARRIER_FREQ 0x00
#define SX127X_IOC_GET_CARRIER_FREQ 0x01

#define SX127X_IOC_SET_MODEM 0x02
#define SX127X_IOC_GET_MODEM 0x03
#define SX127X_IOC_GET_STATUS 0x04
#define SX127X_IOC_GET_RSSI 0x05
#define SX127X_IOC_SET_LOW_DATA_RATE_OPTIMIZ 0x06
#define SX127X_IOC_GET_LOW_DATA_RATE_OPTIMIZ 0x07

#define SX127X_MODEM_BANDWITH_7_8K 0b0000
#define SX127X_MODEM_BANDWITH_10_4K 0b0001
#define SX127X_MODEM_BANDWITH_15_6K 0b0010
#define SX127X_MODEM_BANDWITH_20_8K 0b0011
#define SX127X_MODEM_BANDWITH_31_25K 0b0100
#define SX127X_MODEM_BANDWITH_41_7K 0b0101
#define SX127X_MODEM_BANDWITH_62_5K 0b0110
#define SX127X_MODEM_BANDWITH_125K 0b0111
#define SX127X_MODEM_BANDWITH_250K 0b1000
#define SX127X_MODEM_BANDWITH_500K 0b1001

#define SX127X_MODEM_CODING_RATE_4_5 0b001
#define SX127X_MODEM_CODING_RATE_4_6 0b010
#define SX127X_MODEM_CODING_RATE_4_7 0b011
#define SX127X_MODEM_CODING_RATE_4_8 0b100
#define SX127X_MODEM_IMPLICIT_HEADER_ON 0b1
#define SX127X_MODEM_IMPLICIT_HEADER_OFF 0b0

#define SX127X_MODEM_SPREADING_FACTOR_7 0x07
#define SX127X_MODEM_SPREADING_FACTOR_8 0x08
#define SX127X_MODEM_SPREADING_FACTOR_9 0x09
#define SX127X_MODEM_SPREADING_FACTOR_10 0x0A
#define SX127X_MODEM_SPREADING_FACTOR_11 0x0B
#define SX127X_MODEM_SPREADING_FACTOR_12 0x0C
#define SX127X_MODEM_TX_CONTINUS_ON 0b1
#define SX127X_MODEM_TX_CONTINUS_OFF 0b0
#define SX127X_MODEM_RX_PAYLOAD_CRC_ON 0b1
#define SX127X_MODEM_RX_PAYLOAD_CRC_OFF 0b0

#pragma pack(1)
struct sx127x_modem_s
{
    uint8_t implicit_header : 1;
    uint8_t coding_rate : 3;
    uint8_t band_width : 4;

    uint8_t rx_timeout_msb : 2;
    uint8_t rx_payload_crc : 1;
    uint8_t tx_continus : 1;
    uint8_t spreading_factor : 4;
};

extern int sx127x_register(const char *p_dev_path, FAR struct spi_dev_s *p_spi, int dev_num);

#endif